import nodebitcoin
import docker
import sys

client = docker.from_env()
try:
    client.images.get('node_bitcoin')
except docker.errors.ImageNotFound:
    print "Cargando entorno..."
    try:
        client.images.build(path='.', tag='node_bitcoin', forcerm=True)
    except docker.errors.BuildError:
        print "Ha habido un error con la preparacion del entorno"
    except:
        print "Error desconocido durante la carga del entorno"
except:
    print "Unexpected error:", sys.exc_info()[0]
    raise

def menu_node(number_node):
    node = nodes[int(number_node)-1]
    while True:
        if node.getNetwork()==0:
            select = raw_input("Nodo "+number_node+" Seleccione una opcion:\n V - ver bloques,\n C - ver conexiones,\n A - Añadir conexion,\n D - borrar nodo,\n Z - volver menu anterior,\n X - Salir")
        else:
            select = raw_input("Nodo "+number_node+" Seleccione una opcion:\n V - ver bloques,\n C - ver conexiones,\n B - ver saldo,\n T - ver transacciones,\n P - Realizar transaccion,\n G - generar bloques,\n A - Añadir conexion,\n D - borrar nodo,\n Z - volver menu anterior,\n X - Salir")
        if select == "V":
            print node.getBlocks()
        elif select == "C":
            print node.showAddressConnect()
        elif select == "B":
            print node.getBalance()
        elif select == "T":
            listTrans = node.showListTransactions()
            aux = []
            print ['Address', 'amount', 'confirmations']
            for a,i in enumerate(listTrans):
                if (a+1) % 3 == 0:
                    aux.append(i)
                    print aux
                    aux = []
                else:
                    aux.append(i)
        elif select == "P":
            value = raw_input("Indique valor a enviar o C para cancelar: ")
            if value != "C":
                dest_node = raw_input("Nodo destino o C para cancelar: ")
                if dest_node !="C":
                    node.sendToAddress(int(value), nodes[int(dest_node)-1])
                    print "Enviado"
        elif select == "G":
            blocks = raw_input ("Indique los bloques a crear o C para cancelar: ")
            if blocks !="C":
                node.miningBlock(int(blocks))
                print "Creados"
        elif select == "A":
            connect = raw_input("Indique a que nodo conectar o C para cancelar: ")
            if connect !="C":
                node.addConnection(nodes[int(connect)-1])
                print "Conexion realizada"
        elif select == "D":
            if node.delNode() == True:
                print "node esborrat"
                break
            else:
                print "Ha habido un problema con el borrado del nodo"
        elif select == "Z":
            break
        elif select == "X":
            print "Cancelado por el usuario", sys.exit(0)
        else:
            input("No has indicado ninguna opcion correcta\nPulsa una tecla para continuar\n")
            
nodes = []
connections = []
while True:
    numNodes = raw_input("Indique primero el numero de nodos a desplegar: ")
    if numNodes=="0":
        print "Debe indicar un numero diferente de cero"
    else:
        try:
            int(numNodes)
            break
        except ValueError:
            print "Valor incorrecto, por favor, indique otro"
while True:
    xarxa = raw_input("Sobre que red desea trabajar:\n 0 - maintest\n 1 - testnet\n 2 - regtest\n")
    if (xarxa == '0') or (xarxa == '1') or (xarxa == '2'):
        xarxa = int(xarxa)
        break
    else:
        print "Valor incorrecto"
print "Ha elegido "+numNodes+" nodo(s), por favor, ahora indique con que nodo quiere que vaya conectado cada uno"
numNodes = int(numNodes)
for i in range(numNodes):
    print "\nNodo "+str(i+1)+"\n"
    while True:
        connect = raw_input("Indique nodos a que conectarse (separado por comas ej.2,3,4), E para externo, T sin restriccion, X salir")
        if connect == "X":
            print "Cancelado por el usuario", sys.exit(0)
        elif connect == "T":
            connections.append("")
            break
        elif connect == "E":
            connections.append("0")
            break
        else:
            valid = False
            connect = connect.replace(" ","")
            connections.append(connect.split(","))
            for s in connections[i]:
                try:
                    int(s)
                    valid = True
                except ValueError:
                    print "Uno o varios de los valores no son correctos"
                    valid = False
                    connections.pop()
            if valid == True:
                break              
for n in range(numNodes):
    if connections[n] == "":
        print "Creando la red...Nodo "+str(n+1)
        nodes.append(nodebitcoin.node_bitcoin(xarxa))
    else:
        print "Creando la red...Nodo "+str(n+1)
        nodes.append(nodebitcoin.node_bitcoin(xarxa, connections[n]))
print "\nRed creada"
interaccio=""
while interaccio !="X":
    interaccio = raw_input("Indique:\n N nuevo nodo,\n un numero de nodo para configurarlo/interactuar o\n X para salir")
    if interaccio == "X":
        print "Cancelado por el usuario", sys.exit(0)
    elif interaccio == "N":
        print "\nNodo "+str(len(nodes)+1)+"\n"
        connect = raw_input("Indique nodos a que conectarse (separado por comas), E para externo, T sin restriccion, X salir")
        connections=[]
        if connect == "X":
            print "Cancelado por el usuario", sys.exit(0)
        elif connect == "T":
                connections.append("")
        elif connect == "E":
                connections.append("0")
        else:
            connect = connect.replace(" ","")
            connections.append(connect.split(","))
        if connections == "":
            print "Creando nodo "+str(len(nodes)+1)
            nodes.append(nodebitcoin.node_bitcoin(xarxa))
        else:
            print "Creando nodo "+str(len(nodes)+1)
            nodes.append(nodebitcoin.node_bitcoin(xarxa, connections[0]))
    else:
        menu_node(interaccio)
        


            
            


