import docker
import json
import time

client = docker.from_env()

def decode(text):
    djson = json.loads(text)
    return djson

class node_bitcoin:

    def __init__(self, network, node=[]):
        aux = []
        self.node = node
        self.network = network
        if network == 0:
            self.net = ''
            self.port = "8333"
        if network == 1:
            self.net = '-testnet'
            self.port = "18333"
        if network == 2:
            self.net = '-regtest'
            self.port = "18444"
        if not node:
            #Creacio del contenidor amb Bitcoin sense especificar connexions
            print self.net
            self.client = client.containers.run(image='node_bitcoin', command='bitcoind '+self.net+' -whitelist=172.17.0.0/24', detach=True)
        else:
            for i in node:
                i = int(i)
                if i == 0:
                    aux.append("-connect=178.254.37.97")
                else:
                    aux.append("-connect=172.17.0."+str(i+1)+":"+self.port)
            print self.net+' '+' '.join(aux)
            #Creacio del contenidor amb Bitcoin especificant nodes amb els quals connectar
            self.client = client.containers.run(image='node_bitcoin', command='bitcoind '+self.net+' -whitelist=172.17.0.0/24'+' '+' '.join(aux), detach=True)
        time.sleep(10)

    def test_network(self):
        if self.network == 0:
            return False
        return True

    def getNetwork(self):
        return self.network

    def getBalance(self):
        #Retorna el valor de bitcoins disponibles per fer despesa
        return self.client.exec_run(cmd='bitcoin-cli '+self.net+' getbalance')

    def getBlocks(self):
        #Retorna el numero de blocs descarregat de la xarxa
        return self.client.exec_run(cmd='bitcoin-cli '+self.net+' getblockcount')

    def getIP(self):
        return self.client.exec_run(cmd='hostname -i')

    def getAmount(self):
        #Retorna els valor de les transacions encara no confirmades
        aux = []
        value = decode(self.client.exec_run(cmd='bitcoin-cli '+self.net+' listtransactions'))
        if value:
            for i in range(len(value)):
                aux.append(value[i]['amount'],value[i]['address'])
        return aux

    def delNode(self):
        try:
            self.client.remove(force=True)
            return True
        except docker.errors.APIError:
            return False
        
    def miningBlock(self, value):
        #Generacio de blocs
        #value, nombre de blocs a generar
        if self.test_network() == True:
            return self.client.exec_run(cmd='bitcoin-cli '+self.net+' generate '+str(value))
        else:
            print "No es pot fer en aquesta xarxa"

    def getBlockChainInfo(self):
        #Obtencio d'informacio de la cadena de blocs'
        return decode(self.client.exec_run(cmd='bitcoin-cli '+self.net+' getblockchaininfo'))

    def getNewAddress(self):
        #Creacio d'una nova adreca'
        return self.client.exec_run(cmd='bitcoin-cli '+self.net+' getnewaddress')

    def sendToAddress(self, value, node):
        #Enviament de bitcoins a un node desti
        address = node.getNewAddress()
        return self.client.exec_run(cmd='bitcoin-cli '+self.net+' sendtoaddress '+address+' '+str(value))

    def addConnection(self, node):
        #Afegir una connexio a un node desti
        addressIP = node.getIP()
        return self.client.exec_run(cmd='bitcoin-cli '+self.net+' addnode '+addressIP+':'+self.port+' onetry')
    def delConnection(self, node):
        #Eliminar una connexio d'un node'
        addressIP = node.getIP()
        return self.client.exec_run(cmd='bitcoin-cli '+self.net+' addnode '+addressIP+':'+self.port+' remove')
    def showAddressConnect(self):
        #Mostra el nodes amb qui s'esta connectat'
        listAdd = []
        listAddresses = decode(self.client.exec_run(cmd='bitcoin-cli '+self.net+' getpeerinfo'))
        for i in listAddresses:
            listAdd.append(i['addr'])
        return listAdd
    def showListTransactions(self):
        #Mostra les ultimes transaccions dels nodes
        listTrans = []
        listTransactions = decode(self.client.exec_run(cmd='bitcoin-cli '+self.net+' listtransactions'))
        for i in listTransactions:
            listTrans.append(i['address'])
            listTrans.append(i['amount'])
            listTrans.append(i['confirmations'])
        return listTrans
    












